// dlgzsub.cpp : implementation file
//

#include "stdafx.h"
#include "wz.h"
#include "dlgzsub.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgZSubEntry dialog

CDlgZSubEntry::CDlgZSubEntry(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgZSubEntry::IDD, pParent)
{
	m_advanced=theApp.m_technobabble;
	m_alwaysshow=FALSE;
	m_zstype=Traditional;
	//{{AFX_DATA_INIT(CDlgZSubEntry)
	m_group = "";
	m_type = 0;
	m_recipient = "";
	m_instance = "";
	m_check = m_advanced;
	//}}AFX_DATA_INIT
}

void CDlgZSubEntry::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgZSubEntry)
	DDX_Text(pDX, IDC_GROUP, m_group);
	DDX_Radio(pDX, IDC_TRADITIONAL, m_type);
	DDX_Text(pDX, IDC_RECIPIENT, m_recipient);
	DDV_MaxChars(pDX, m_recipient, 40);
	DDX_Text(pDX, IDC_INSTANCE, m_instance);
	DDX_Check(pDX, IDC_ADVANCED_ENTRY, m_check);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDlgZSubEntry, CDialog)
	//{{AFX_MSG_MAP(CDlgZSubEntry)
	ON_BN_CLICKED(IDC_TRADITIONAL, OnClickedTraditional)
	ON_BN_CLICKED(IDC_PERSONAL, OnClickedPersonal)
	ON_BN_CLICKED(IDC_OUTGOING, OnClickedOutgoing)
	ON_BN_CLICKED(IDC_ADVANCED_ENTRY, OnClickedAdvancedEntry)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgZSubEntry message handlers

#define ShowDlgItem(x) GetDlgItem(x)->ShowWindow(SW_SHOW);

#define HideDlgItem(x) GetDlgItem(x)->ShowWindow(SW_HIDE);

void CDlgZSubEntry::OnClickedTraditional()
{   
	m_zstype=Traditional;
	UpdateFieldNames();
}

void CDlgZSubEntry::OnClickedPersonal()
{   
	m_zstype=Personal;
	UpdateFieldNames();
}

void CDlgZSubEntry::OnClickedOutgoing()
{                    
	m_zstype=Outgoing;
	UpdateFieldNames();
}

void CDlgZSubEntry::OnClickedAdvancedEntry()
{
	if (IsDlgButtonChecked(IDC_PERSONAL)) 
		m_alwaysshow=IsDlgButtonChecked(IDC_ADVANCED_ENTRY);
	else 
		m_advanced=IsDlgButtonChecked(IDC_ADVANCED_ENTRY);
	UpdateFieldNames();
}                      

void CDlgZSubEntry::UpdateFieldNames()
{
	if (IsDlgButtonChecked(IDC_PERSONAL)) {
		CheckDlgButton(IDC_ADVANCED_ENTRY,m_alwaysshow);
		GetDlgItem(IDC_ADVANCED_ENTRY)->SetWindowText("&Always show in sender");
		GetDlgItem(IDC_STATIC_RECIPIENT)->SetWindowText("&Username");
		HideDlgItem(IDC_STATIC_GROUP);
		HideDlgItem(IDC_GROUP);
		HideDlgItem(IDC_STATIC_INSTANCE);
		HideDlgItem(IDC_INSTANCE);	
	} else {
		CheckDlgButton(IDC_ADVANCED_ENTRY,m_advanced);
		if (m_advanced) {
			GetDlgItem(IDC_STATIC_GROUP)->SetWindowText("&Class");
			GetDlgItem(IDC_ADVANCED_ENTRY)->SetWindowText("&Advanced Entry");
			GetDlgItem(IDC_STATIC_RECIPIENT)->SetWindowText("&Recipient");		
			ShowDlgItem(IDC_STATIC_INSTANCE);
			ShowDlgItem(IDC_INSTANCE);
			ShowDlgItem(IDC_STATIC_GROUP);
			ShowDlgItem(IDC_GROUP);
		} else {
			GetDlgItem(IDC_STATIC_GROUP)->SetWindowText("&Group");
			GetDlgItem(IDC_ADVANCED_ENTRY)->SetWindowText("&Advanced Entry");
			GetDlgItem(IDC_STATIC_RECIPIENT)->SetWindowText("&Recipient");		
			HideDlgItem(IDC_STATIC_INSTANCE);
			HideDlgItem(IDC_INSTANCE);
			ShowDlgItem(IDC_STATIC_GROUP);
			ShowDlgItem(IDC_GROUP);
		}		
	}
}


BOOL CDlgZSubEntry::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	UpdateFieldNames();	
                    
	GetDlgItem(IDC_GROUP)->SetFocus();                  
	
	return FALSE;  // return TRUE  unless you set the focus to a control
}
