// listview.cpp : implementation of the CListView class
//

#include "stdafx.h"
#include "wz.h"

#include "zdoc.h"
#include "listview.h"
#include "stckview.h"
#include "sendview.h"
#include "wgrmview.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CListView

IMPLEMENT_DYNCREATE(CListView, CView)

BEGIN_MESSAGE_MAP(CListView, CView)
	//{{AFX_MSG_MAP(CListView)
	ON_COMMAND(ID_VIEW_SENDER, OnViewSender)
	ON_COMMAND(ID_VIEW_STACK, OnViewStack)
	ON_COMMAND(ID_VIEW_WINDOWGRAM, OnViewWindowgram)
	ON_UPDATE_COMMAND_UI(ID_VIEW_WINDOWGRAM, OnUpdateViewWindowgram)
	ON_UPDATE_COMMAND_UI(ID_VIEW_STACK, OnUpdateViewStack)
	ON_UPDATE_COMMAND_UI(ID_VIEW_SENDER, OnUpdateViewSender)
	ON_COMMAND(ID_CONTROL_SUBSCRIBE, OnControlSubscribe)
	ON_COMMAND(ID_CONTROL_UNSUBSCRIBE, OnControlUnsubscribe)
	ON_COMMAND(ID_VIEW_LISTOPTIONS, OnViewListoptions)
	ON_WM_CREATE()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CListView construction/destruction

CListView::CListView()
{
	// TODO: add construction code here
}

CListView::~CListView()
{
}

/////////////////////////////////////////////////////////////////////////////
// CListView drawing

void CListView::OnDraw(CDC* pDC)
{
	CZDoc* pDoc = GetDocument();

	// TODO: add draw code here
}



/////////////////////////////////////////////////////////////////////////////
// CListView diagnostics

#ifdef _DEBUG
void CListView::AssertValid() const
{
	CView::AssertValid();
}

void CListView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CZDoc* CListView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CZDoc)));
	return (CZDoc*) m_pDocument;
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CListView message handlers

void CListView::OnViewSender()
{
	CZDoc* doc=(CZDoc *)GetDocument();
	CView* vw;
	POSITION pos;
	
	pos=doc->GetFirstViewPosition();
	while (vw=doc->GetNextView(pos))
		if (vw->IsKindOf(RUNTIME_CLASS(CSenderView)))
			break;
	if (vw) {
		vw->ShowWindow(SW_RESTORE);
		vw->SetFocus();
	} else {
		CFrameWnd* fr;
	
		fr=theApp.m_dtsender->CreateNewFrame(GetDocument(),(CFrameWnd*)theApp.m_pMainWnd);
		theApp.m_dtsender->InitialUpdateFrame(fr,GetDocument());
	}
	return;
}

void CListView::OnViewStack()
{
	CZDoc* doc=(CZDoc *)GetDocument();
	CView* vw;
	POSITION pos;
	
	pos=doc->GetFirstViewPosition();
	while (vw=doc->GetNextView(pos))
		if (vw->IsKindOf(RUNTIME_CLASS(CStackView)))
			break;
	if (vw) {
		vw->ShowWindow(SW_RESTORE);
		vw->SetFocus();
	} else {
		CFrameWnd* fr;
	
		fr=theApp.m_dtstack->CreateNewFrame(GetDocument(),(CFrameWnd*)theApp.m_pMainWnd);
		theApp.m_dtstack->InitialUpdateFrame(fr,GetDocument());
	}
	return;
}

void CListView::OnViewWindowgram()
{
	CZDoc* doc=(CZDoc *)GetDocument();
	CView* vw;
	POSITION pos;
	
	pos=doc->GetFirstViewPosition();
	while (vw=doc->GetNextView(pos))
		if (vw->IsKindOf(RUNTIME_CLASS(CWGramView)))
			break;
	if (vw) {
		vw->ShowWindow(SW_RESTORE);
		vw->SetFocus();
	} else {
		CFrameWnd* fr;
	
		fr=theApp.m_dtwgram->CreateNewFrame(GetDocument(),(CFrameWnd*)theApp.m_pMainWnd);
		theApp.m_dtwgram->InitialUpdateFrame(fr,GetDocument());
	}
	return;
}

void CListView::OnUpdateViewWindowgram(CCmdUI* pCmdUI)
{
	CZDoc* doc=(CZDoc *)GetDocument();
	CView* vw;
	POSITION pos;
	
	pos=doc->GetFirstViewPosition();
	while (vw=doc->GetNextView(pos)) {
		if (vw->IsKindOf(RUNTIME_CLASS(CWGramView))) {
			pCmdUI->SetCheck(1);
			return;
		}
	}
	pCmdUI->SetCheck(0);
	return;
}

void CListView::OnUpdateViewStack(CCmdUI* pCmdUI)
{
	CZDoc* doc=(CZDoc *)GetDocument();
	CView* vw;
	POSITION pos;
	
	pos=doc->GetFirstViewPosition();
	while (vw=doc->GetNextView(pos)) {
		if (vw->IsKindOf(RUNTIME_CLASS(CStackView))) {
			pCmdUI->SetCheck(1);
			return;
		}
	}
	pCmdUI->SetCheck(0);
	return;
}

void CListView::OnUpdateViewSender(CCmdUI* pCmdUI)
{
	CZDoc* doc=(CZDoc *)GetDocument();
	CView* vw;
	POSITION pos;
	
	pos=doc->GetFirstViewPosition();
	while (vw=doc->GetNextView(pos)) {
		if (vw->IsKindOf(RUNTIME_CLASS(CSenderView))) {
			pCmdUI->SetCheck(1);
			return;
		}
	}
	pCmdUI->SetCheck(0);
	return;
}

void CListView::OnControlSubscribe()
{
	// TODO: Add your command handler code here
	
}

void CListView::OnControlUnsubscribe()
{
	// TODO: Add your command handler code here
	
}

void CListView::OnViewListoptions()
{
	// TODO: Add your command handler code here
	
}

int CListView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	CRect rect;

	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;

	GetClientRect(rect);

	m_list.Create(WS_CHILD | WS_VISIBLE | WS_VSCROLL | LBS_EXTENDEDSEL |
		LBS_NOTIFY | LBS_OWNERDRAWVARIABLE | LBS_DISABLENOSCROLL, rect,
		this, IDC_LISTVIEW);
	
	return 0;
}

void CListView::OnSize(UINT nType, int cx, int cy)
{
	CView::OnSize(nType, cx, cy);
	
	m_list.SetWindowPos(NULL,0,0,cx,cy,SWP_SHOWWINDOW | SWP_NOZORDER);
}

void CListView::OnReceiveZGram(CZGram *zg)
{
	
}
