// listview.h : interface of the CListView class
//
/////////////////////////////////////////////////////////////////////////////

#include "zlsbox.h"
#include "myview.h"
#include "zsub.h"

struct ListItem {
	CZGram* zg;
	UINT lno;
	BOOL expd;
};

class CListView : public CMyView
{
friend class CZApp;

protected: // create from serialization only
	CListView();
	DECLARE_DYNCREATE(CListView)

// Attributes
public:
	CZDoc* GetDocument();
	CZepListBox m_list;

// Operations
public:
	void OnReceiveZGram(CZGram *);

// Implementation
public:
	virtual ~CListView();
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif


// Generated message map functions
protected:
	//{{AFX_MSG(CListView)
	afx_msg void OnViewSender();
	afx_msg void OnViewStack();
	afx_msg void OnViewWindowgram();
	afx_msg void OnUpdateViewWindowgram(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewStack(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewSender(CCmdUI* pCmdUI);
	afx_msg void OnControlSubscribe();
	afx_msg void OnControlUnsubscribe();
	afx_msg void OnViewListoptions();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG	// debug version in listview.cpp
inline CZDoc* CListView::GetDocument()
   { return (CZDoc*) m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
