// sendview.cpp : implementation file
//

#include "stdafx.h"
#include "wz.h"  
                      
#include "zdoc.h"
#include "sendview.h"
#include "stckview.h"
#include "listview.h"
#include "wgrmview.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSenderView

IMPLEMENT_DYNCREATE(CSenderView, CView)

BEGIN_MESSAGE_MAP(CSenderView, CView)
	//{{AFX_MSG_MAP(CSenderView)
	ON_COMMAND(ID_VIEW_LIST, OnViewList)
	ON_COMMAND(ID_VIEW_STACK, OnViewStack)
	ON_COMMAND(ID_VIEW_WINDOWGRAM, OnViewWindowgram)
	ON_UPDATE_COMMAND_UI(ID_VIEW_WINDOWGRAM, OnUpdateViewWindowgram)
	ON_UPDATE_COMMAND_UI(ID_VIEW_STACK, OnUpdateViewStack)
	ON_UPDATE_COMMAND_UI(ID_VIEW_LIST, OnUpdateViewList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CSenderView::CSenderView()
{
}

CSenderView::~CSenderView()
{
}

/////////////////////////////////////////////////////////////////////////////
// CSenderView drawing

void CSenderView::OnDraw(CDC* pDC)
{
	CZDoc* pDoc = GetDocument();
	// TODO: add draw code here

}

/////////////////////////////////////////////////////////////////////////////
// CSenderView diagnostics

#ifdef _DEBUG
void CSenderView::AssertValid() const
{
	CView::AssertValid();
}

void CSenderView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CZDoc* CSenderView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CZDoc)));
	return (CZDoc*) m_pDocument;
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSenderView message handlers


void CSenderView::OnViewList()
{
	CZDoc* doc=(CZDoc *)GetDocument();
	CView* vw;
	POSITION pos;
	
	pos=doc->GetFirstViewPosition();
	while (vw=doc->GetNextView(pos))
		if (vw->IsKindOf(RUNTIME_CLASS(CListView)))
			break;
	if (vw) {
		vw->ShowWindow(SW_RESTORE);
		vw->SetFocus();
	} else {
		CFrameWnd* fr;
	
		fr=theApp.m_dtlist->CreateNewFrame(GetDocument(),(CFrameWnd*)theApp.m_pMainWnd);
		theApp.m_dtlist->InitialUpdateFrame(fr,GetDocument());
	}
	return;
}

void CSenderView::OnViewStack()
{
	CZDoc* doc=(CZDoc *)GetDocument();
	CView* vw;
	POSITION pos;
	
	pos=doc->GetFirstViewPosition();
	while (vw=doc->GetNextView(pos))
		if (vw->IsKindOf(RUNTIME_CLASS(CStackView)))
			break;
	if (vw) {
		vw->ShowWindow(SW_RESTORE);
		vw->SetFocus();
	} else {
		CFrameWnd* fr;
	
		fr=theApp.m_dtstack->CreateNewFrame(GetDocument(),(CFrameWnd*)theApp.m_pMainWnd);
		theApp.m_dtstack->InitialUpdateFrame(fr,GetDocument());
	}
	return;
}

void CSenderView::OnViewWindowgram()
{
	CZDoc* doc=(CZDoc *)GetDocument();
	CView* vw;
	POSITION pos;
	
	pos=doc->GetFirstViewPosition();
	while (vw=doc->GetNextView(pos))
		if (vw->IsKindOf(RUNTIME_CLASS(CWGramView)))
			break;
	if (vw) {
		vw->ShowWindow(SW_RESTORE);
		vw->SetFocus();
	} else {
		CFrameWnd* fr;
	
		fr=theApp.m_dtwgram->CreateNewFrame(GetDocument(),(CFrameWnd*)theApp.m_pMainWnd);
		theApp.m_dtwgram->InitialUpdateFrame(fr,GetDocument());
	}
	return;
}

void CSenderView::OnUpdateViewWindowgram(CCmdUI* pCmdUI)
{
	CZDoc* doc=(CZDoc *)GetDocument();
	CView* vw;
	POSITION pos;
	
	pos=doc->GetFirstViewPosition();
	while (vw=doc->GetNextView(pos)) {
		if (vw->IsKindOf(RUNTIME_CLASS(CWGramView))) {
			pCmdUI->SetCheck(1);
			return;
		}
	}
	pCmdUI->SetCheck(0);
	return;
}

void CSenderView::OnUpdateViewStack(CCmdUI* pCmdUI)
{
	CZDoc* doc=(CZDoc *)GetDocument();
	CView* vw;
	POSITION pos;
	
	pos=doc->GetFirstViewPosition();
	while (vw=doc->GetNextView(pos)) {
		if (vw->IsKindOf(RUNTIME_CLASS(CStackView))) {
			pCmdUI->SetCheck(1);
			return;
		}
	}
	pCmdUI->SetCheck(0);
	return;
}

void CSenderView::OnUpdateViewList(CCmdUI* pCmdUI)
{
	CZDoc* doc=(CZDoc *)GetDocument();
	CView* vw;
	POSITION pos;
	
	pos=doc->GetFirstViewPosition();
	while (vw=doc->GetNextView(pos)) {
		if (vw->IsKindOf(RUNTIME_CLASS(CListView))) {
			pCmdUI->SetCheck(1);
			return;
		}
	}
	pCmdUI->SetCheck(0);
	return;
}

void CSenderView::OnReceiveZGram(CZGram *)
{                            

}