// stckview.cpp : implementation file
//

#include "stdafx.h"
#include "wz.h"
#include "zdoc.h"
#include "stckview.h"
#include "listview.h"
#include "sendview.h"
#include "wgrmview.h"
#include "topfrm.h"
#include "stackfrm.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CStackView

IMPLEMENT_DYNCREATE(CStackView, CScrollView)

CStackView::CStackView()
{
	m_zcur=0;
}

CStackView::~CStackView()
{
}


BEGIN_MESSAGE_MAP(CStackView, CScrollView)
	//{{AFX_MSG_MAP(CStackView)
	ON_COMMAND(ID_VIEW_LIST, OnViewList)
	ON_COMMAND(ID_VIEW_SENDER, OnViewSender)
	ON_UPDATE_COMMAND_UI(ID_VIEW_LIST, OnUpdateViewList)
	ON_COMMAND(ID_VIEW_WINDOWGRAM, OnViewWindowgram)
	ON_UPDATE_COMMAND_UI(ID_VIEW_WINDOWGRAM, OnUpdateViewWindowgram)
	ON_UPDATE_COMMAND_UI(ID_VIEW_SENDER, OnUpdateViewSender)
	ON_WM_CREATE()
	ON_COMMAND(ID_CMD_DELZGRAM, OnCmdDelzgram)
	ON_COMMAND(ID_CMD_ZWRITE, OnCmdZwrite)
	ON_COMMAND(ID_CMD_NEXTZGRAM, OnCmdNextzgram)
	ON_COMMAND(ID_CMD_PREVZGRAM, OnCmdPrevzgram)
	ON_UPDATE_COMMAND_UI(ID_CMD_NEXTZGRAM, OnUpdateCmdNextzgram)
	ON_UPDATE_COMMAND_UI(ID_CMD_PREVZGRAM, OnUpdateCmdPrevzgram)
	ON_WM_PAINT()
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_NZGRAM, OnUpdateIndicatorNzgram)
	ON_COMMAND(ID_CMD_ZREPLY, OnCmdZreply)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStackView drawing

void CStackView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: add draw code here
}

/////////////////////////////////////////////////////////////////////////////
// CStackView message handlers

int CStackView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;

	CSize sz(0,0);
	SetScrollSizes(MM_TEXT,sz);
	
	return 0;
}

void CStackView::OnInitialUpdate()
{
	CStackFrame* frame=(CStackFrame*)GetParentFrame();
	char itbuf1[18],itbuf2[18];
	frame->SetStatusText((CString)""+itoa((m_zgrams.GetSize())?
		(m_zcur+1):0,itbuf1,10)+"/"+itoa(m_zgrams.GetSize(),itbuf2,10));
}

void CStackView::OnViewList()
{
	CZDoc* doc=(CZDoc *)GetDocument();
	CView* vw;
	POSITION pos;
	
	pos=doc->GetFirstViewPosition();
	while (vw=doc->GetNextView(pos))
		if (vw->IsKindOf(RUNTIME_CLASS(CListView)))
			break;
	if (vw) {
		vw->ShowWindow(SW_RESTORE);
		vw->SetFocus();
	} else {
		CFrameWnd* fr;
	
		fr=theApp.m_dtlist->CreateNewFrame(GetDocument(),(CFrameWnd*)theApp.m_pMainWnd);
		theApp.m_dtlist->InitialUpdateFrame(fr,GetDocument());
	}
	return;
}

void CStackView::OnViewSender()
{
	CZDoc* doc=(CZDoc *)GetDocument();
	CView* vw;
	POSITION pos;
	
	pos=doc->GetFirstViewPosition();
	while (vw=doc->GetNextView(pos))
		if (vw->IsKindOf(RUNTIME_CLASS(CSenderView)))
			break;
	if (vw) {
		vw->ShowWindow(SW_RESTORE);
		vw->SetFocus();
	} else {
		CFrameWnd* fr;
	
		fr=theApp.m_dtsender->CreateNewFrame(GetDocument(),(CFrameWnd*)theApp.m_pMainWnd);
		theApp.m_dtsender->InitialUpdateFrame(fr,GetDocument());
	}
	return;
}

void CStackView::OnViewWindowgram()
{
	CZDoc* doc=(CZDoc *)GetDocument();
	CView* vw;
	POSITION pos;
	
	pos=doc->GetFirstViewPosition();
	while (vw=doc->GetNextView(pos))
		if (vw->IsKindOf(RUNTIME_CLASS(CWGramView)))
			break;
	if (vw) {
		vw->ShowWindow(SW_RESTORE);
		vw->SetFocus();
	} else {
		CFrameWnd* fr;
	
		fr=theApp.m_dtwgram->CreateNewFrame(GetDocument(),(CFrameWnd*)theApp.m_pMainWnd);
		theApp.m_dtwgram->InitialUpdateFrame(fr,GetDocument());
	}
	return;
}

void CStackView::OnUpdateViewList(CCmdUI* pCmdUI)
{
	CZDoc* doc=(CZDoc *)GetDocument();
	CView* vw;
	POSITION pos;
	
	pos=doc->GetFirstViewPosition();
	while (vw=doc->GetNextView(pos)) {
		if (vw->IsKindOf(RUNTIME_CLASS(CListView))) {
			pCmdUI->SetCheck(1);
			return;
		}
	}
	pCmdUI->SetCheck(0);
	return;
}

void CStackView::OnUpdateViewWindowgram(CCmdUI* pCmdUI)
{
	CZDoc* doc=(CZDoc *)GetDocument();
	CView* vw;
	POSITION pos;
	
	pos=doc->GetFirstViewPosition();
	while (vw=doc->GetNextView(pos)) {
		if (vw->IsKindOf(RUNTIME_CLASS(CWGramView))) {
			pCmdUI->SetCheck(1);
			return;
		}
	}
	pCmdUI->SetCheck(0);
	return;
}

void CStackView::OnUpdateViewSender(CCmdUI* pCmdUI)
{
	CZDoc* doc=(CZDoc *)GetDocument();
	CView* vw;
	POSITION pos;
	
	pos=doc->GetFirstViewPosition();
	while (vw=doc->GetNextView(pos)) {
		if (vw->IsKindOf(RUNTIME_CLASS(CSenderView))) {
			pCmdUI->SetCheck(1);
			return;
		}
	}
	pCmdUI->SetCheck(0);
	return;
}

void CStackView::OnCmdDelzgram()
{
	// TODO: Add your command handler code here
	
}

void CStackView::OnCmdZwrite()
{
	// TODO: Add your command handler code here
	
}


void CStackView::OnCmdZreply()
{
	// TODO: Add your command handler code here
	
}
void CStackView::OnCmdNextzgram()
{
	if (m_zcur>=m_zgrams.GetSize()-1) return;
	CStackFrame* frame=(CStackFrame*)GetParentFrame();
	m_zcur++; Invalidate();	
	frame->m_wndToolBar.OnUpdateCmdUI(frame,TRUE);
}

void CStackView::OnCmdPrevzgram()
{
	if (!m_zcur) return;
	CStackFrame* frame=(CStackFrame*)GetParentFrame();
	m_zcur--; Invalidate();
	frame->m_wndToolBar.OnUpdateCmdUI(frame,TRUE);
}

void CStackView::OnUpdateCmdNextzgram(CCmdUI* pCmdUI)
{
	if (m_zcur>=m_zgrams.GetSize()-1) 
		pCmdUI->Enable(FALSE);
	else
		pCmdUI->Enable(TRUE);	
}

void CStackView::OnUpdateCmdPrevzgram(CCmdUI* pCmdUI)
{
	if (!m_zcur)
		pCmdUI->Enable(FALSE);
	else
		pCmdUI->Enable(TRUE);	
}

void CStackView::OnUpdateIndicatorNzgram(CCmdUI* pCmdUI)
{
	pCmdUI->Enable();
	pCmdUI->SetCheck(2);
}

void CStackView::OnReceiveZGram(CZGram *zg)
{   
	UINT nzg=m_zgrams.GetSize();
	m_zgrams.InsertAt(nzg,zg->Format());

	if (!nzg)
		Invalidate();
	else {
		CStackFrame* frame=(CStackFrame*)GetParentFrame();
		char itbuf1[18],itbuf2[18];
		frame->SetStatusText((CString)""+itoa((m_zgrams.GetSize())?
			(m_zcur+1):0,itbuf1,10)+"/"+itoa(m_zgrams.GetSize(),itbuf2,10));
		frame->m_wndToolBar.OnUpdateCmdUI(frame,TRUE);
	}	
}

void CStackView::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	if (m_zgrams.GetSize()) {
		CRect r;
	    CString thisMsg,thisLine;
	    UINT y=0;
	    CPoint x(0,0);
	    CSize sz,thisSize(0,0);
		CString m_s=m_zgrams[m_zcur];

		x=GetDeviceScrollPosition();
	    thisMsg=m_s;
	    while (thisMsg.GetLength()) {
	    	int f=thisMsg.Find('\n');
	    	if (f<0) {
	    		thisLine=thisMsg;
	    		thisMsg="";
	    	} else {
		    	thisLine=thisMsg.Left(f);
			    thisMsg=thisMsg.Right(thisMsg.GetLength()-f-1);
			}    
		    sz=dc.TabbedTextOut(-x.x,-x.y,thisLine,thisLine.GetLength(),
		    	0,NULL,0);
		    y+=sz.cy;
		    x.y-=sz.cy;
		    thisSize.cx=(thisSize.cx<sz.cx)?sz.cx:thisSize.cx;
		}
		
		thisSize.cy=y;
	    SetScrollSizes(MM_TEXT,thisSize);
	} else {
		CSize sz(0,0);
		SetScrollSizes(MM_TEXT,sz);
	}	
}
