// wgamview.cpp : implementation file
//

#include "stdafx.h"
#include "wz.h"
#include "zdoc.h"
#include "wgrmview.h"
#include "stckview.h"
#include "listview.h"
#include "sendview.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWGramView

IMPLEMENT_DYNCREATE(CWGramView, CView)

CWGramView::CWGramView()
{
}

CWGramView::~CWGramView()
{
}


BEGIN_MESSAGE_MAP(CWGramView, CView)
	//{{AFX_MSG_MAP(CWGramView)
	ON_COMMAND(ID_VIEW_LIST, OnViewList)
	ON_COMMAND(ID_VIEW_SENDER, OnViewSender)
	ON_COMMAND(ID_VIEW_STACK, OnViewStack)
	ON_UPDATE_COMMAND_UI(ID_VIEW_SENDER, OnUpdateViewSender)
	ON_UPDATE_COMMAND_UI(ID_VIEW_LIST, OnUpdateViewList)
	ON_UPDATE_COMMAND_UI(ID_VIEW_STACK, OnUpdateViewStack)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWGramView drawing

void CWGramView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: add draw code here
}

/////////////////////////////////////////////////////////////////////////////
// CWGramView message handlers

void CWGramView::OnViewList()
{
	CZDoc* doc=(CZDoc *)GetDocument();
	CView* vw;
	POSITION pos;
	
	pos=doc->GetFirstViewPosition();
	while (vw=doc->GetNextView(pos))
		if (vw->IsKindOf(RUNTIME_CLASS(CListView)))
			break;
	if (vw) {
		vw->ShowWindow(SW_RESTORE);
		vw->SetFocus();
	} else {
		CFrameWnd* fr;
	
		fr=theApp.m_dtlist->CreateNewFrame(GetDocument(),(CFrameWnd*)theApp.m_pMainWnd);
		theApp.m_dtlist->InitialUpdateFrame(fr,GetDocument());
	}
	return;
}

void CWGramView::OnViewSender()
{
	CZDoc* doc=(CZDoc *)GetDocument();
	CView* vw;
	POSITION pos;
	
	pos=doc->GetFirstViewPosition();
	while (vw=doc->GetNextView(pos))
		if (vw->IsKindOf(RUNTIME_CLASS(CSenderView)))
			break;
	if (vw) {
		vw->ShowWindow(SW_RESTORE);
		vw->SetFocus();
	} else {
		CFrameWnd* fr;
	
		fr=theApp.m_dtsender->CreateNewFrame(GetDocument(),(CFrameWnd*)theApp.m_pMainWnd);
		theApp.m_dtsender->InitialUpdateFrame(fr,GetDocument());
	}
	return;
}

void CWGramView::OnViewStack()
{
	CZDoc* doc=(CZDoc *)GetDocument();
	CView* vw;
	POSITION pos;
	
	pos=doc->GetFirstViewPosition();
	while (vw=doc->GetNextView(pos))
		if (vw->IsKindOf(RUNTIME_CLASS(CStackView)))
			break;
	if (vw) {
		vw->ShowWindow(SW_RESTORE);
		vw->SetFocus();
	} else {
		CFrameWnd* fr;
	
		fr=theApp.m_dtstack->CreateNewFrame(GetDocument(),(CFrameWnd*)theApp.m_pMainWnd);
		theApp.m_dtstack->InitialUpdateFrame(fr,GetDocument());
	}
	return;
}

void CWGramView::OnUpdateViewSender(CCmdUI* pCmdUI)
{
	CZDoc* doc=(CZDoc *)GetDocument();
	CView* vw;
	POSITION pos;
	
	pos=doc->GetFirstViewPosition();
	while (vw=doc->GetNextView(pos)) {
		if (vw->IsKindOf(RUNTIME_CLASS(CSenderView))) {
			pCmdUI->SetCheck(1);
			return;
		}
	}
	pCmdUI->SetCheck(0);
	return;
}

void CWGramView::OnUpdateViewList(CCmdUI* pCmdUI)
{
	CZDoc* doc=(CZDoc *)GetDocument();
	CView* vw;
	POSITION pos;
	
	pos=doc->GetFirstViewPosition();
	while (vw=doc->GetNextView(pos)) {
		if (vw->IsKindOf(RUNTIME_CLASS(CListView))) {
			pCmdUI->SetCheck(1);
			return;
		}
	}
	pCmdUI->SetCheck(0);
	return;
}

void CWGramView::OnUpdateViewStack(CCmdUI* pCmdUI)
{
	CZDoc* doc=(CZDoc *)GetDocument();
	CView* vw;
	POSITION pos;
	
	pos=doc->GetFirstViewPosition();
	while (vw=doc->GetNextView(pos)) {
		if (vw->IsKindOf(RUNTIME_CLASS(CStackView))) {
			pCmdUI->SetCheck(1);
			return;
		}
	}
	pCmdUI->SetCheck(0);
	return;
}

void CWGramView::OnReceiveZGram(CZGram *)
{

}