// wz.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "wz.h"

#include "iconfrm.h" 
#include "topfrm.h"
#include "stackfrm.h"
#include "zdoc.h"
#include "listview.h"
#include "stckview.h"
#include "sendview.h"
#include "wgrmview.h"
#include "dlgglob.h"
#include "testdlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CZApp

BEGIN_MESSAGE_MAP(CZApp, CWinApp)
	//{{AFX_MSG_MAP(CZApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_CONFIG_GLOBAL, OnConfigGlobal)
	ON_COMMAND(ID_HIDE_ALL, OnHideAll)
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Global help commands
	ON_COMMAND(ID_HELP_INDEX, CWinApp::OnHelpIndex)
	ON_COMMAND(ID_HELP_USING, CWinApp::OnHelpUsing)
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CWinApp::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CWinApp::OnHelpIndex)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CZApp construction

CZApp::CZApp()
{
	// Place all significant initialization in InitInstance
	m_newdoc=0;
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CZApp object

CZApp NEAR theApp;

/////////////////////////////////////////////////////////////////////////////
// CZApp initialization

BOOL CZApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

	SetDialogBkColor();        // set dialog background color to gray
	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	CString username;	
	if (getenv("NAME")) 
		username=getenv("NAME");
	else 
		username=GetProfileString("WinZephyr","Username");

	m_MyProfileName=username+".ZP";

	m_st_personal_top=GetPrivateProfileInt("Stack","PersonalToTop",0,m_MyProfileName);
	m_st_reverse_stack=GetPrivateProfileInt("Stack","ReverseStack",0,m_MyProfileName);
	m_technobabble=GetPrivateProfileInt("General","Technobabble",0,m_MyProfileName);
	m_save_on_exit=GetPrivateProfileInt("General","SaveOnExit",1,m_MyProfileName);
	{
		char buf[256];
		GetPrivateProfileString("General","DefKrbRealm","",buf,256,m_MyProfileName);
		m_krbrealm=buf;
	}
	m_default_view=(ViewSet)GetPrivateProfileInt("General","DefaultView",0,m_MyProfileName);
	if (!m_default_view) {
		CString s=GetProfileString("General","DefaultView","");

		if (!s.CompareNoCase("WindowGram"))
			m_default_view=VS_WGV;
		else if	(!s.CompareNoCase("Stack"))
			m_default_view=VS_STV;
		else if (!s.CompareNoCase("Sender"))
			m_default_view=VS_SNV;	
		else
			m_default_view=VS_LSV;
	}	
	m_wg_reverse_stack=GetPrivateProfileInt("WindowGram","ReverseStack",0,m_MyProfileName);
	m_wg_titlebar=GetPrivateProfileInt("WindowGram","TitleBar",1,m_MyProfileName);

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	AddDocTemplate(m_dtlist=new CMultiDocTemplate(IDR_ZLISTTYPE,
			RUNTIME_CLASS(CZDoc),
			RUNTIME_CLASS(CTopFrame),
			RUNTIME_CLASS(CListView)));

	AddDocTemplate(m_dtstack=new CMultiDocTemplate(IDR_ZSTACKTYPE,
			RUNTIME_CLASS(CZDoc),
			RUNTIME_CLASS(CStackFrame),
			RUNTIME_CLASS(CStackView)));

	AddDocTemplate(m_dtsender=new CMultiDocTemplate(IDR_ZSENDERTYPE,
			RUNTIME_CLASS(CZDoc),
			RUNTIME_CLASS(CTopFrame),
			RUNTIME_CLASS(CSenderView)));

	AddDocTemplate(m_dtwgram=new CMultiDocTemplate(IDR_ZWGRAMTYPE,
			RUNTIME_CLASS(CZDoc),
			RUNTIME_CLASS(CTopFrame),
			RUNTIME_CLASS(CWGramView)));

	// create main MDI Frame window
	CIconFrame* pMainFrame = new CIconFrame;                                
	pMainFrame->LoadFrame(IDR_MAINFRAME,WS_CAPTION | WS_SYSMENU | WS_VISIBLE);
	pMainFrame->UpdateWindow();
	m_pMainWnd = pMainFrame;

	m_td = new CTestDlg;
	m_td->Create(MAKEINTRESOURCE(IDD_TEST));

	// enable file manager drag/drop and DDE Execute open
	m_pMainWnd->DragAcceptFiles();
	EnableShellOpen();
	RegisterShellFileTypes();

	// simple command line parsing
	if (m_lpCmdLine[0] == '\0')
	{
		// create a new (empty) document
		OnFileNew();
	}
	else if ((m_lpCmdLine[0] == '-' || m_lpCmdLine[0] == '/') &&
		(m_lpCmdLine[1] == 'e' || m_lpCmdLine[1] == 'E'))
	{
		// program launched embedded - wait for DDE or OLE open
	}
	else
	{
		// open an existing document
		OpenDocumentFile(m_lpCmdLine);
	}

	return TRUE;
}

int CZApp::ExitInstance()
{                            
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CZApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CZApp commands

void CZApp::OnConfigGlobal()
{
	CDlgGlobalOptions dgo;
	              
	dgo.m_sto_personal_top=m_st_personal_top;
	dgo.m_sto_reverse_stack=m_st_reverse_stack;
	dgo.m_technobabble=m_technobabble;
	dgo.m_save_on_exit=m_save_on_exit;
	dgo.m_realm=m_krbrealm;
	dgo.m_zgo_reverse_stack=m_wg_reverse_stack;
	dgo.m_zgo_titlebar=m_wg_titlebar;
	switch (m_default_view) {
		case VS_SNV:
			dgo.m_default_views="Sender";
			break;
		case VS_STV:
			dgo.m_default_views="Stack";
			break;	
		case VS_WGV:
			dgo.m_default_views="WindowGram";
			break;
		default:
			dgo.m_default_views="List";
	}		
	dgo.DoModal();
	if (dgo.m_default_views=="WindowGram")
		m_default_view=VS_WGV;
	else if	(dgo.m_default_views=="Stack")
		m_default_view=VS_STV;
	else if (dgo.m_default_views=="Sender")
		m_default_view=VS_SNV;	
	else
		m_default_view=VS_LSV;
	
	m_st_personal_top=dgo.m_sto_personal_top;
	m_st_reverse_stack=dgo.m_sto_reverse_stack;
	m_technobabble=dgo.m_technobabble;
	m_save_on_exit=dgo.m_save_on_exit;
	m_krbrealm=dgo.m_realm;
	m_wg_reverse_stack=dgo.m_zgo_reverse_stack;
	m_wg_titlebar=dgo.m_zgo_titlebar;

	CString s;
	char t[18];
	
	itoa(m_st_personal_top,t,10);
	WritePrivateProfileString("Stack","PersonalToTop",t,m_MyProfileName);
	itoa(m_st_reverse_stack,t,10);
	WritePrivateProfileString("Stack","ReverseStack",t,m_MyProfileName);
	itoa(m_technobabble,t,10);
	WritePrivateProfileString("General","Technobabble",t,m_MyProfileName);
	itoa(m_save_on_exit,t,10);
	WritePrivateProfileString("General","SaveOnExit",t,m_MyProfileName);
	WritePrivateProfileString("General","DefKrbRealm",m_krbrealm,m_MyProfileName);
	itoa(m_default_view,t,10);
	WritePrivateProfileString("General","DefaultView",t,m_MyProfileName);
	itoa(m_wg_reverse_stack,t,10);
	WritePrivateProfileString("WindowGram","ReverseStack",t,m_MyProfileName);
	itoa(m_wg_titlebar,t,10);
	WritePrivateProfileString("WindowGram","TitleBar",t,m_MyProfileName);	
}


void CZApp::OnHideAll()
{
		
}

void CZApp::OnFileNew()
{           
	CMultiDocTemplate *dt;
	CFrameWnd* fr;
	CZDoc* doc;
	CString s;	
	char t[18];
    
	switch (m_default_view) {
		case VS_WGV:
			dt=m_dtwgram;
			break;
		case VS_STV:
			dt=m_dtstack;
			break;
		case VS_SNV:
			dt=m_dtsender;
			break;
		default:  
			dt=m_dtlist;
	}	
	
	fr=dt->CreateNewFrame(doc=(CZDoc*)dt->CreateNewDocument(),(CFrameWnd*)m_pMainWnd);
	s="ZSub";
	itoa(++m_newdoc,t,10);
	doc->SetTitle(s+t);
	dt->InitialUpdateFrame(fr,doc);
}

void CZApp::OnReceiveZGram(CZGram *zg)
{
	POSITION pos,pos2;
    CMultiDocTemplate *dt[4];
    CRuntimeClass *rtc[4];
    CZDoc *doc;
    CZSub *zs;
    
    dt[0]=m_dtwgram;	rtc[0]=RUNTIME_CLASS(CWGramView);
    dt[1]=m_dtstack;	rtc[1]=RUNTIME_CLASS(CStackView);
    dt[2]=m_dtsender;	rtc[2]=RUNTIME_CLASS(CSenderView);
    dt[3]=m_dtlist;		rtc[3]=RUNTIME_CLASS(CListView);
    
    for (int i=0;i<4;i++) {
    	pos=dt[i]->GetFirstDocPosition();
    	while (pos) {
    		doc=(CZDoc*)dt[i]->GetNextDoc(pos);
    		pos2=doc->m_zsubs.GetHeadPosition();
    		while (pos2) {
    			zs=(CZSub*)doc->m_zsubs.GetNext(pos2);
    			if (zs->Match(zg)) {
    				doc->OnReceiveZGram(zg,rtc[i]);
    				break;
    			}    				
    		}
    	}
    }
}
