// zsub.cpp : implementation of the CZSub class
//

#include "stdafx.h"
#include "wz.h"

#include "zsub.h"
#include "dlgzsub.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CZSub

IMPLEMENT_SERIAL(CZSub, CObject, 1)

CZSub::CZSub()
{
}

void CZSub::Dialog()
{
	CDlgZSubEntry zse;
	
	switch (m_type) {
		case Personal:
			zse.m_type=1;
			zse.m_recipient=m_pusername;
			zse.m_check=m_pshow;
			break;
		case Outgoing:          
			zse.m_type=2;
			if (theApp.m_technobabble) {
				zse.m_group=m_oclass;
				zse.m_instance=m_oinstance;
			} else {
				// Parse m_oclass, m_oinstance -> zse.m_group...
			}
			zse.m_recipient=m_orecipient;
			break;
		default:	// Traditional
			zse.m_type=0;
			if (theApp.m_technobabble) {
				zse.m_group=m_tclass;
				zse.m_instance=m_tinstance;
			} else {
				// Parse m_tclass, m_tinstance -> zse.m_group...
			}
			zse.m_recipient=m_orecipient;
	}	
	
	zse.DoModal();
	switch (zse.m_type) {
		case 1:
			m_type=Personal;
			m_pusername=zse.m_recipient;
			m_pshow=zse.m_check;
			break;
		case 2:
			m_type=Outgoing;    
			if (zse.m_check) {
				m_oclass=zse.m_group;
				m_oinstance=zse.m_instance;
			} else {
				// parse zse.m_group -> m_oclass, m_oinstance
				
			}
			m_orecipient=zse.m_recipient;
			break;
		default:		
			m_type=Traditional;
			if (zse.m_check) {
				m_tclass=zse.m_group;
				m_tinstance=zse.m_instance;
			} else {
				// parse zse.m_group for class & instance
				
			}
			m_trecipient=zse.m_recipient;
	}
			
}

CZSub::~CZSub()
{
}

void CZSub::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

BOOL CZSub::Match(CZGram *zg)			// returns true if zephyrgram 
{										// matches the subscription...
	switch (m_type) {
		case Traditional:
			if (zg->m_type!=Traditional) return FALSE;
			if (!m_tclass.CompareNoCase(zg->m_class))
				if ((m_tinstance=="*")||(!m_tinstance.CompareNoCase(zg->m_instance))) {
					if (m_trecipient=="*") 
						return (zg->m_recipient=="*");
					else
						return (zg->m_recipient!="*");
				}
			return FALSE;		
		case Personal:
			if (zg->m_type==Outgoing) return FALSE;
			if (!zg->m_class.CompareNoCase("login"))
				return !zg->m_instance.CompareNoCase(m_pusername);
			return FALSE;	
		case Outgoing:
			if (zg->m_type!=Outgoing) return FALSE;
			if (!m_oclass.CompareNoCase(zg->m_class))
				if ((m_oinstance=="*")||(!m_oinstance.CompareNoCase(zg->m_instance))) {
					if (m_orecipient=="*") 
						return (zg->m_recipient=="*");
					else
						return (zg->m_recipient!="*");
				}
			return FALSE;
	}
	return FALSE;
}
