// zsub.h : interface of the CZSub class and the CZGram class
//
/////////////////////////////////////////////////////////////////////////////
                    
class CZGram : public CObject
{   
	DECLARE_SERIAL(CZGram);
	
public:
	ZSubType m_type;			// Will never be Personal...
	CString m_class;
	CString m_instance;
	CString m_recipient;
	CString m_opcode;
	CString m_default;
	CString m_sender;
	CString m_kind;
	CString m_sender_address;
	CTime m_time;
	EAuth m_auth;
	CStringArray m_fields;
	
public:
	virtual void Serialize(CArchive &ar);
	UINT NumLines();
	CString Format();
};

class CZSub : public CObject
{
protected: 
	DECLARE_SERIAL(CZSub)
	
// Attributes
public:
	CZSub();
	ZSubType m_type;
	union {
		struct {
			CString m_tclass;
			CString m_tinstance;
			CString m_trecipient;
		};
		struct {
			CString m_pusername;
			BOOL m_pshow;
		};
		struct {
			CString m_oclass;
			CString m_oinstance;
			CString m_orecipient;
		};
	};

// Operations
public:
	BOOL Match(CZGram *);					// returns true if zephyrgram 
											// matches the subscription...
	// Subscribe, Unsubscribe operations...    

// Implementation
public:
	virtual ~CZSub();
	void Dialog();							// pass it the parent window for 
									        // 	the dlgbox...
	virtual void Serialize(CArchive& ar);	// overridden for CZSub i/o
};

